searchNodes=[{"ref":"FluxAMQP.html","title":"FluxAMQP","type":"module","doc":"An interface to connect to AMQP broker, sending and retrieving messages."},{"ref":"FluxAMQP.html#close_connection/1","title":"FluxAMQP.close_connection/1","type":"function","doc":"Closes an open Connection. Parameters connection - The AMQP.Connection.t/0 struct. Examples iex&gt; connection = FluxAMQP.connect!(__MODULE__, only_connect?: true) ...&gt; FluxAMQP.close_connection(connection) :ok"},{"ref":"FluxAMQP.html#close_connection!/1","title":"FluxAMQP.close_connection!/1","type":"function","doc":"Closes an open Connection. Similar to close_connection/1, but raises FluxAMQP.Error.t/0 on failure. Examples iex&gt; connection = FluxAMQP.connect!(__MODULE__, only_connect?: true) ...&gt; FluxAMQP.close_connection!(connection) :ok"},{"ref":"FluxAMQP.html#connect/2","title":"FluxAMQP.connect/2","type":"function","doc":"Open a AMQP.Connection.t/0 and configure it. Parameters consumer - The module which will consume AMQP messages. Accepts module/0. opts - Keyword list with connection settings. Definition is the same as application configuration and the opts defined here are merged with the application configuration. Additionally, if the option :only_connect? is true, this function will not configure channel and will return a AMQP.Connection.t/0, otherwise will configure a AMQP.Channel.t/0 and will return it. Can be blank. Accepts keyword/0. Examples iex&gt; result = FluxAMQP.connect(__MODULE__, only_connect?: true) ...&gt; with {:ok, %AMQP.Connection{}} &lt;- result, do: :passed :passed iex&gt; result = FluxAMQP.connect(__MODULE__) ...&gt; with {:ok, %AMQP.Channel{}} &lt;- result, do: :passed :passed"},{"ref":"FluxAMQP.html#connect!/2","title":"FluxAMQP.connect!/2","type":"function","doc":"Open a AMQP.Connection.t/0 and configure it. Similar to connect/2, but raises FluxAMQP.Error.t/0 on failure. Examples iex&gt; result = FluxAMQP.connect!(__MODULE__, only_connect?: true) ...&gt; with %AMQP.Connection{} &lt;- result, do: :passed :passed iex&gt; result = FluxAMQP.connect!(__MODULE__) ...&gt; with %AMQP.Channel{} &lt;- result, do: :passed :passed"},{"ref":"FluxAMQP.html#open_channel/1","title":"FluxAMQP.open_channel/1","type":"function","doc":"Open a AMQP.Channel.t/0 based on AMQP.Connection.t/0. Parameters connection - The AMQP.Connection.t/0 struct. Examples iex&gt; connection = FluxAMQP.connect!(MODULE, only_connect?: true) ...&gt; result = FluxAMQP.open_channel(connection) ...&gt; with {:ok, %AMQP.Channel{}} &lt;- result, do: :passed :passed"},{"ref":"FluxAMQP.html#open_channel!/1","title":"FluxAMQP.open_channel!/1","type":"function","doc":"Open a AMQP.Channel.t/0 based on AMQP.Connection.t/0. Similar to open_channel/1, but raises FluxAMQP.Error.t/0 on failure. Examples iex&gt; connection = FluxAMQP.connect!(MODULE, only_connect?: true) ...&gt; result = FluxAMQP.open_channel!(connection) ...&gt; with %AMQP.Channel{} &lt;- result, do: :passed :passed"},{"ref":"FluxAMQP.html#send/3","title":"FluxAMQP.send/3","type":"function","doc":"Send AMQP message. Parameters payload - The message. Accepts String.t/0. routing_key - The AMQP routing key which the message will be sent. Accepts String.t/0. opts - Keyword list with options. Can be blank. Accepts keyword/0. Examples iex&gt; FluxAMQP.send(&quot;Hello, World!&quot;, &quot;some.amqp.route&quot;) :ok Options :broker - Keyword list with broker connection settings. Definition is the same as application configuration and the opts defined here are merged with the broker application configuration. Accepts keyword/0. :channel - A valid AMQP.Channel.t/0 struct. If not set, a new channel will be created. :close_connection? - If true, it will close the connection. Defaults to true. Accepts boolean/0. :connection - A valid AMQP.Connection.t/0 struct. If not set, a new connection will be created. :publish_options - A Keyword list with valid AMQP.Basic.publish/5 options. Defaults to an [persistent: true]. Accepts keyword/0."},{"ref":"FluxAMQP.html#send!/3","title":"FluxAMQP.send!/3","type":"function","doc":"Send AMQP message. Similar to send/3, but raises FluxAMQP.Error.t/0 on failure. Examples iex&gt; FluxAMQP.send!(&quot;Hello, World!&quot;, &quot;some.amqp.route&quot;) :ok"},{"ref":"FluxAMQP.Consumer.html","title":"FluxAMQP.Consumer","type":"behaviour","doc":"Module responsible to consume AMQP messages. The main approach to consume is done by defining a module which extends FluxAMQP.Consumer and implements routing_keys/0 and consume/3 functions: defmodule MyApp.AMQP.Consumer do use FluxAMQP.Consumer @impl FluxAMQP.Consumer def routing_keys do [ &quot;route.example&quot;, {&quot;another.route.example&quot;, &quot;amq.direct&quot;} ] end @impl FluxAMQP.Consumer def consume(channel, delivery_tag, routing_key, payload) do # Handle message end end Then, set the connection as a worker child on your application: defmodule MyApp.Application do use Application @impl Application def start(_type, _args) do import Supervisor.Spec children = [ worker(MyApp.AMQP.Consumer, []) ] opts = [strategy: :one_for_one] Supervisor.start_link(children, opts) end end If routing_keys/0 returns an empty list, FluxAMQP will try to extract the routing keys from the application configuration."},{"ref":"FluxAMQP.Consumer.html#c:consume/3","title":"FluxAMQP.Consumer.consume/3","type":"callback","doc":""},{"ref":"FluxAMQP.Consumer.html#c:routing_keys/0","title":"FluxAMQP.Consumer.routing_keys/0","type":"callback","doc":""},{"ref":"FluxAMQP.ConsumerTestUtils.html","title":"FluxAMQP.ConsumerTestUtils","type":"module","doc":"Simplify the creation of test cases for modules using FluxAMQP"},{"ref":"FluxAMQP.ConsumerTestUtils.html#add_log_message/2","title":"FluxAMQP.ConsumerTestUtils.add_log_message/2","type":"function","doc":"Add a log message which will be tested after the execution of the consumer. Parameters utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. message - A String.t/0 log message. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = ...&gt; MyConsumer ...&gt; |&gt; setup_consumer_test() ...&gt; |&gt; add_log_message(&quot;MyConsumer received a message&quot;) ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#consumer_test/1","title":"FluxAMQP.ConsumerTestUtils.consumer_test/1","type":"function","doc":"Execute a test case which will assert the result and the log messages of FluxAMQP.Consumer.consume/3 implementation call made by the consumer module. Parameters utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = ...&gt; FluxAMQP.ConsumerTestUtils.MyConsumer ...&gt; |&gt; setup_consumer_test() ...&gt; |&gt; set_meta(%{routing_key: &quot;test.route&quot;}) ...&gt; |&gt; set_payload(~s({&quot;success&quot;: true})) ...&gt; |&gt; do_before(fn _utils, _channel -&gt; :ok end) ...&gt; |&gt; set_result(:ok) ...&gt; |&gt; add_log_message(&quot;MyConsumer received a message&quot;) ...&gt; |&gt; consumer_test() ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#do_before/2","title":"FluxAMQP.ConsumerTestUtils.do_before/2","type":"function","doc":"Set a function/0 which will be executed before the consumption assertion. Parameters utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. do_before_function - A function/0 with two parameters: utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. channel - Consumer AMQP.Channel.t/0. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = ...&gt; MyConsumer ...&gt; |&gt; setup_consumer_test() ...&gt; |&gt; set_meta(%{routing_key: &quot;test&quot;}) ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#set_meta/2","title":"FluxAMQP.ConsumerTestUtils.set_meta/2","type":"function","doc":"Set a map/0 that behaves as the meta data when one AMQP message is received. Parameters utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. meta - A map/0 that behaves as the AMQP message meta. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = ...&gt; MyConsumer ...&gt; |&gt; setup_consumer_test() ...&gt; |&gt; set_meta(%{routing_key: &quot;test&quot;}) ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#set_payload/2","title":"FluxAMQP.ConsumerTestUtils.set_payload/2","type":"function","doc":"Set a String.t/0 that behaves as the AMQP message received by the consumer. Parameters utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. payload - A String.t/0 that behaves as the AMQP message. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = ...&gt; MyConsumer ...&gt; |&gt; setup_consumer_test() ...&gt; |&gt; set_payload(~s({&quot;hello&quot;: &quot;world&quot;})) ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#set_result/2","title":"FluxAMQP.ConsumerTestUtils.set_result/2","type":"function","doc":"Create FluxAMQP.ConsumerTestUtils.t/0. This is the starting function to a consumer pipe test case. Parameters consumer - A module which uses FluxAMQP.Consumer. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = setup_consumer_test(MyConsumer) ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#setup_consumer_test/1","title":"FluxAMQP.ConsumerTestUtils.setup_consumer_test/1","type":"function","doc":"Set the result expected to receive after a FluxAMQP.Consumer.consume/3 implementation call. Parameters utils - FluxAMQP.ConsumerTestUtils.t/0 with the data for a consumer test. result - Expected result for the current consumer test. Examples iex&gt; import FluxAMQP.ConsumerTestUtils ...&gt; utils = ...&gt; MyConsumer ...&gt; |&gt; setup_consumer_test() ...&gt; |&gt; set_result(:ok) ...&gt; with %FluxAMQP.ConsumerTestUtils{} &lt;- utils, do: :passed :passed"},{"ref":"FluxAMQP.ConsumerTestUtils.html#t:t/0","title":"FluxAMQP.ConsumerTestUtils.t/0","type":"type","doc":""},{"ref":"FluxAMQP.Error.html","title":"FluxAMQP.Error","type":"exception","doc":"FluxAMQP error module."},{"ref":"FluxAMQP.Error.html#message/1","title":"FluxAMQP.Error.message/1","type":"function","doc":"Generate message String.t/0 based on :reason. Parameters error - The FluxAMQP.Error.t/0. Examples iex&gt; error = %FluxAMQP.Error{reason: :failed_to_connect} ...&gt; FluxAMQP.Error.message(error) &quot;failed to connect to AMQP broker&quot;"},{"ref":"FluxAMQP.Error.html#to_tuple/1","title":"FluxAMQP.Error.to_tuple/1","type":"function","doc":"Generate {:error, atom} based on :reason. Parameters error - The t:FluxRedis.Error.t/0. Examples iex&gt; error = %FluxAMQP.Error{reason: :failed_to_connect} ...&gt; FluxAMQP.Error.to_tuple(error) {:error, :failed_to_connect}"},{"ref":"FluxAMQP.Error.html#t:t/0","title":"FluxAMQP.Error.t/0","type":"type","doc":"FluxAMQP error struct"},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#0-0-5-2019-11-25","title":"Changelog - 0.0.5 - 2019-11-25","type":"extras","doc":"Added: FluxAMQP.Error, the error struct for ! functions. The following ! functions: FluxAMQP.close_connection!/1 FluxAMQP.connect!/2 FluxAMQP.send!/3 FluxAMQP.open_channel!/1 FluxAMQP.ConsumerTestUtils.do_before/2, to allow connection manipulation before the assertions. :prefetch_count connection application config. Changed: FluxAMQP connections now acts as work queues. Removed: Exchange options on connections. Exchange settings on application configuration :routing_keys."},{"ref":"changelog.html#0-0-4-2019-11-07","title":"Changelog - 0.0.4 - 2019-11-07","type":"extras","doc":"Added: FluxAMQP.ConsumerTestUtils, a module created to simplify the creation of test cases for modules using FluxAMQP.Consumer. Changed: FluxAMQP.Consumer Default exchange changed from amq.topic to amq.direct."},{"ref":"changelog.html#0-0-3-2019-09-03","title":"Changelog - 0.0.3 - 2019-09-03","type":"extras","doc":"Changed: Callback FluxAMQP.Consumer.consume/3 return type changed from atom/0 to any/0. Fixed: Fix conditional not working as expected on FluxAMQP.Consumer."},{"ref":"changelog.html#0-0-2-2019-09-01","title":"Changelog - 0.0.2 - 2019-09-01","type":"extras","doc":"Changed: Every logger now uses metadata to describe information. There are three metadata keys that can be filtered on logger settings: :flux_amqp_params - The params received by function. :flux_amqp_result - The result of the function. :error - The error result of the function."},{"ref":"changelog.html#0-0-1-2019-08-31","title":"Changelog - 0.0.1 - 2019-08-31","type":"extras","doc":"Added: The project is available on GitLab and Hex. Notes: Minor changes (0.0.x) from the current version will be logged to this file. When a major change is released (0.x.0 or x.0.0), the changelog of the previous major change will be grouped as a single change."},{"ref":"readme.html","title":"Flux AMQP","type":"extras","doc":"Flux AMQP Interface to connect to AMQP broker, sending and retrieving messages. It uses AMQP, check their documentation to understand how this library perform the connection, configuration, consumption and delivery of AMQP messages."},{"ref":"readme.html#usage","title":"Flux AMQP - Usage","type":"extras","doc":"Add Flux AMQP as a dependency in your mix.exs file: def deps do [{:flux_amqp, &quot;~&gt; 0.0.5&quot;}] end FluxAMQP describes how to define and close a connection and how to send a message. FluxAMQP.Consumer describes how to consume AMQP messages."},{"ref":"readme.html#application-configuration","title":"Flux AMQP - Application Configuration","type":"extras","doc":"import Config # Default values config :flux_amqp, broker: [ uri: &quot;amqp://guest:guest@rabbitmq&quot;, connection: [ prefetch_count: 50, reattempt_connection_on_failure?: true, reattempt: [ maximum_attempts: :infinity, waiting_ms: 10_000 ] ] ], routing_keys: [] Configuration Options :broker - Set the AMQP broker. Accepts keyword/0. Options are: :uri - The AMQP Broker URI. Defaults to amqp://guest:guest@rabbitmq. Accepts String.t/0. :connection - Set the AMQP broker connection. Accepts keyword/0. Options are: :prefetch_count - Set the maximum amount of non-acknowledged messages each consumer will retain. Defaults to 50. Accepts integer/0. :reattempt_connection_on_failure? - If true, when a connection to AMQP broker fails, a reattempt will be performed. Defaults to true. Accepts boolean/0. :reattempt - Set the reattempt settings. Accepts keyword/0. Options are: :maximum_attempts - How many attempts should be performed in case of connection failure. If set to :infinity, it will try until connection succeeds. Defaults to :infinity. Accepts integer/0 or :infinity. :waiting_ms - How many milliseconds should wait before reattempting connection. Defaults to 10_000. Accepts integer/0. :routing_keys - The AMQP routing keys which the messages will be consumed. Defaults to an emptt list. Accepts String.t/0."}]